;
; IDL Event Callback Procedures
; idlim_eventcb
;
; Generated on: 02/21/2005 10:00.30
;
;
; Empty stub procedure used for autoloading.
;
pro idlim_eventcb

end

;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released.
;       Normal buttons do not generate events when released, so
;       SELECT will always be 1. However, toggle buttons (created by
;       parenting a button to an exclusive or non-exclusive base)
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
;*****************************************************************************************
;**********************enhance_contrast**********************************************************
;*****************************************************************************************
function enhance_contrast, b



orez=1000     ;orez kraju histogramu     ;tady!!!
i=0
x=0
while (x lt orez) do begin
 i=i+1
 temp=where(b lt i, x)
 ;print, 'count', x
endwhile

j=255
x=0
while (x lt orez) do begin
 j=j-1
 temp=where(b gt j, x)
 ;print, 'count', x
endwhile


;print, 'final i, j',i,j
ij=intarr(2)
ij[0]=i
ij[1]=j
return, ij
end
;*****************************************************************************************
;**********************row_equal**********************************************************
;*****************************************************************************************
function row_eq,b2
b=b2
siz=size(b)
xsize=siz[1]
ysize=siz[2]
;help, b
;print, xsize, ysize
for i=0, ysize-1 do begin
    ; b[*,i]=(b[*,i]-min(b[*,i]))/(max(b[*,i])-min(b[*,i]))
    result=moment(b[*,i])
    b[*,i]=b[*,i]-result[0]+128
endfor
;print, b[*,100]

return, b

end

;*****************************************************************************************
;******************************plain_sub**************************************************
;*****************************************************************************************
function plain_sub,b2
b=b2
siz=size(b)
sizex=siz[1]
sizey=siz[2]
b=b-sfit(b,1, kx=koef)
;res=sfit(b,1, kx=koef)
;for j=0,sizex-1 do for k=0,sizey-1 do b[j,k]=b[j,k]-(koef[0,0]+koef[1,0]*k+koef[0,1]*j+koef[1,1]*j*k)

;print, "koef", koef
b=(b-min(b));/(max(bmp)-min(bmp))
return, b
end

;*****************************************************************************************
;**************************plain_sub_area*************************************************
;*****************************************************************************************
function plain_sub_area,b2,areacoord
b=b2
siz=size(b)
sizex=siz[1]
sizey=siz[2]
area=b[areacoord[0,0]:areacoord[0,1],areacoord[1,0]:areacoord[1,1]]

res=sfit(area,1, kx=koef)
for j=0,sizex-1 do for k=0,sizey-1 do b[j,k]=b[j,k]-(koef[0,0]+koef[1,0]*k+koef[0,1]*j+koef[1,1]*j*k)
;b=(b-min(b))
return,b
end



;*****************************************************************************************
;*************************select_area*****************************************************
;*****************************************************************************************
function select_area, nic
common data, bmp
wset, 0
siz=size(bmp)
;print, 'siz', siz
sizex=siz[1]
sizey=siz[2]
cursor, x0,y0,/down, /norm
x0=fix(sizex*x0)
y0=fix(sizey*y0)
;print, x0,y0
cursor, x1,y1, /down, /norm
x1=fix(sizex*x1)
y1=fix(sizey*y1)
;print, x1,y1

xmin=min([x0,x1])
xmax=max([x0,x1])
ymin=min([y0,y1])
ymax=max([y0,y1])
;print, [[xmin,ymin],[xmax,ymax]]
return, [[xmin,ymin],[xmax,ymax]]
end

;-----------------------------------------------------------------
;-----------------------------------------------------------------
;-----------------------------------------------------------------

function mix, jpeg_in

sizejpeg=size(jpeg_in)
sizex=sizejpeg(1)
sizey=sizejpeg(2)

tr=jpeg_in*0



 for x=0, sizex/2-1 do begin                   ;transformace - preskladani
  for y=0, sizey/2-1 do begin
   tr[x,y]=jpeg_in[x+sizex/2,y+sizey/2]
   tr[x+sizex/2,y]=jpeg_in[x,y+sizey/2]
   tr[x,y+sizey/2]=jpeg_in[x+sizex/2,y]
   tr[x+sizex/2,y+sizey/2]=jpeg_in[x,y]
  endfor
endfor
return, tr
;tv, abs(tr)*1000

end

function mytest, x
print, 'mytest ok'
return, 0
end

;-----------------------------------------------------------------
;-----------------------OPEN_IMG----------------------------------
;-----------------------------------------------------------------

pro open_IMG, Event, file_loaded=file_loaded    ;keyword file_loaded pi zavoln procedury open_IMG zpsob znovuoteven u otevenho souboru
common data, bmp
common data1, bmp_a, bmp_b
common channels, bmp_vfw, bmp_vbw, bmp_cfw, bmp_cbw, bmp_lfw, bmp_lbw, bmp_ldos, set_channels
common filename, file
common version2, ver, btempl, lockin ;version2 doplnn o informaci o exstenci lock-in kanlu
common scale, x_nm, sizex, step_xy, const_z
common curr, current_fw
common lutblock, set_lut
common directories, dir_main, dir_templates, dir_data
common active_window, active_window
common lineexport, scan, lex_vfw, lex_vbw, lex_cfw, lex_cbw, lex_lfw, lex_lbw, lex_ldos

chbox_ldos=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_LDOS')
widget_control,chbox_ldos, sensitive = 0       ;string(10B) .. novy radek
rbut_ldos=widget_info(Event.top, FIND_BY_UNAME='WID_RBUT_LDOS')
widget_control, rbut_ldos, sensitive = 0       ;string(10B) .. novy radek

set_channels = [0, 0, 0, 0, 0, 0] ;pole s informacemi o aktivovanch/deakt. kanlech, inicializace pole

chbox_cfw=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_CFW')
set_channels[0] = widget_info(chbox_cfw, /button_set)

chbox_cbw=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_CBW')
set_channels[1] = widget_info(chbox_cbw, /button_set)

chbox_vfw=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_VFW')
set_channels[2] = widget_info(chbox_vfw, /button_set)

chbox_vbw=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_VBW')
set_channels[3] = widget_info(chbox_vbw, /button_set)

chbox_lfw=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_LFW')
set_channels[4] = widget_info(chbox_lfw, /button_set)

chbox_lbw=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_LBW')
set_channels[5] = widget_info(chbox_lbw, /button_set)

;text=widget_info(Event.top, FIND_BY_UNAME='WID_SLIDER_0')
;widget_control,text,set_value=a

set_plot, 'win'
lut_ini

temp = mytest(1)

dir_main = FILE_WHICH("idlim.prc") ;nalezne hlavn soubor idlim.prc a ulo jeho cestu do promnn cur
cd, dir_main, current=dir_main              ;do promnn dir_templates ulo cestu k adresi s templates
dir_templates = dir_main+"\templates" ;do promnn dir_templates ulo cestu k adresi s templates
dir_data = dir_main+"\data"

cd, dir_templates  ;nastav jako pracovn adres \templates ze stvajcho cur adresecd, dir_templates  ;nastav jako pracovn adres \templates ze stvajcho cur adrese


IF (keyword_set(file_loaded) EQ 0) THEN BEGIN ;/file_loaded keyword se pouv pro proceduru reopen
    file = dialog_pickfile(PATH='..\STM_data', title='Select a file', filter="*.img")
    IF (file EQ '') THEN BEGIN
    goto, label_stop    ;When pressing the STORNO button during selecting a file to open the whole procedure is being overjumped just before the end of open_img.
    ENDIF
ENDIF

    rbut_vbw = widget_info(Event.top, FIND_BY_UNAME='WID_RBUT_VBW')
    widget_control, rbut_vbw, /set_button
    active_window = 4

FOR i=1,8 DO wdelete, i     ;Zave vechna dve oteven okna --- nutn, aby se neduplikovala okna z pedchozch soubor
;file_loaded = 0

print, "dir_main     ", dir_main
print, "dir_templates", dir_templates

selected_area=0

get_version
print, 'size x : ', sizex

;if sizex ne 512 then begin;
    ;print, 'neni 512x512'
    ;endif

print, 'ver', ver,'ver'
Bdata= Read_binary(file, template=btempl)
if ver eq 'F' then begin
    voltage_fw=bdata.voltage_fw
    voltage_bw=bdata.voltage_bw
    current_fw=bdata.current_fw
    current_bw=bdata.current_bw
endif else begin
    voltage_fw=bdata.voltage
    voltage_bw=bdata.voltage
    current_fw=bdata.current
    current_bw=bdata.current
endelse

    txt=' '+file+string(10B) ;vype informace o souboru, 10B nov dek
    txt=txt+string(9b)+'Img version:'+ string(9b)+string(ver)+string(10B)
    txt=txt+string(9b)+'Resolution:'+ string(bdata.sizexy)+string(10B)
    txt=txt+string(9b)+'date:'+ string(fix(bdata.day))+ '.'+string(fix(bdata.mon))+'.'+ string(bdata.year)+string(10B)+string(9b)+'time:'+ string(fix(bdata.hour))+':'+string(fix(bdata.mins))+':'+string(fix(bdata.sec))+string(10B)
    txt=txt+string(9b)+'voltage fw:'+string(voltage_fw)+string(10B)+string(9b)+'voltage bw:'+string(voltage_bw)+string(10B)+ string(9b)+'current fw:'+ string(current_fw)+string(10B)+ string(9b)+'current bw:'+ string(current_bw)+string(10B)
    txt=txt+string(9b)+'scan speed: '+ string(bdata.scan_speed) +string(10B)+string(9b)+'x offset:'+ string(bdata.xof) +string(10B)+string(9b)+ 'y offset:'+ string(bdata.yof)+string(10B)
    txt=txt+string(9b)+'size [nm]: '+ string(bdata.sizexy*bdata.step_xy)

x_nm=bdata.sizexy*bdata.step_xy
step_xy = bdata.step_xy
const_z = bdata.const_z

help, txt
text=widget_info(Event.top, FIND_BY_UNAME='WID_LABEL_0')
widget_control,text,set_value=txt[0]       ;string(10B) .. novy radek

text=widget_info(Event.top, FIND_BY_UNAME='WID_TEXT_channel')   ;lut
widget_control,text,get_value=channel


case ver of
  'IMG1': begin
         BMP=(bdata.ar[*,*,channel])    ;0...current image 1...z image
         bmp=reverse(bmp,2)
       end
  'S'   : begin
           BMP=(bdata.ar[*,*,channel])  ;0,1...current image 2,3...z image
           bmp=reverse(reverse(bmp,2))
          end
  'F'   : begin
         bmp_cfw=(bdata.ar[*,*,0])  ;nate postupn jednotliv kanly cfw.. current_forward atd.
         bmp_cbw=(bdata.ar[*,*,1])
         bmp_vfw=(bdata.ar[*,*,2])
         bmp_vbw=(bdata.ar[*,*,3])

        bmp_cfw = reverse(bmp_cfw,2)
        bmp_cbw = reverse(reverse(bmp_cbw,2))
        bmp_vfw = reverse(bmp_vfw,2)
        bmp_vbw = reverse(reverse(bmp_vbw,2))
         IF (lockin EQ 1) THEN BEGIN
            bmp_lfw = (bdata.ar[*,*,4])
            bmp_lfw = reverse(bmp_lfw,2)    ;pravdpodobn nutn stejnm zpsobem pevrtit lockin
            bmp_lbw = (bdata.ar[*,*,5])
            bmp_lbw = reverse(reverse(bmp_lbw,2))
            bmp_b = bmp_lfw
            bmp_a = bmp_cfw
         ENDIF  ELSE BEGIN  ;pokud nen lockinov signl, vytvo przdn pole
            bmp_lfw=INTARR(512,512)
            bmp_lbw=INTARR(512,512)
         ENDELSE
           BMP=(bdata.ar[*,*,channel])  ;0,1...current image 2,3...z image
           BMP = reverse(reverse(bmp,2))
       end

  else  : begin
         res=DIALOG_MESSAGE('unknown file format')
         BMP=intarr(128,128)*0
       end
endcase

if channel eq '0' or channel eq '2' then bmp=reverse(bmp)


text=widget_info(Event.top, FIND_BY_UNAME='WID_TEXT_orez')   ;lut ;zjist velikost nastavenho oezu a ped jej do procedury oez
widget_control,text,get_value=orez

Orez_okraju, bmp, orez

Orez_okraju, bmp_cfw, orez
Orez_okraju, bmp_cbw, orez
Orez_okraju, bmp_vfw, orez
Orez_okraju, bmp_vbw, orez

IF (lockin EQ 1) THEN BEGIN ; provede oez v ppad existence lock-in mapy
 Orez_okraju, bmp_lfw, orez
 Orez_okraju, bmp_lbw, orez
ENDIF

scan = bmp_vbw ;scan je nutn pro sprvn klovn exportu lini --- pi oteven se nat Voltage BW
lex_cfw = bmp_cfw
lex_cbw = bmp_cbw
lex_vfw = bmp_vfw
lex_vbw = bmp_vbw
lex_lfw = bmp_lfw
lex_lbw = bmp_lbw


button_reopen = widget_info(Event.top, FIND_BY_UNAME="WID_BUTTON_11")   ;umon pouvat tlatko reopen
widget_control, button_reopen, sensitive = 1    ;aktivuje ReOpen

IF LOCKIN EQ 0 THEN BEGIN ;aktivuje nebo deaktivuje monost volby lockinu
chbox_lbw=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_LBW')
widget_control,chbox_lbw, sensitive = 0       ;string(10B) .. novy radek
chbox_lfw=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_LFW')
widget_control,chbox_lfw, sensitive = 0       ;string(10B) .. novy radek

rbut_lfw=widget_info(Event.top, FIND_BY_UNAME='WID_RBUT_LFW')
widget_control, rbut_lfw, sensitive = 0       ;string(10B) .. novy radek
rbut_lbw=widget_info(Event.top, FIND_BY_UNAME='WID_RBUT_LBW')
widget_control, rbut_lbw, sensitive = 0       ;string(10B) .. novy radek

button = widget_info(Event.top, FIND_BY_UNAME="WID_BUTTON_13")   ;znemon pouvat tlatko Extract Current and Lockin Img
widget_control, button, sensitive = 0
button = widget_info(Event.top, FIND_BY_UNAME="WID_BUTTON_14")   ;znemon pout Get Shift
widget_control, button, sensitive = 0
button = widget_info(Event.top, FIND_BY_UNAME="WID_BUTTON_12")   ;znemon pouvat tlatko Make LDOS map
widget_control, button, sensitive = 0
button = widget_info(Event.top, FIND_BY_UNAME="WID_BUTTON_15")   ;Znemon pout taltko LDOS again
widget_control, button, sensitive = 0
ENDIF ELSE BEGIN
chbox_lbw=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_LBW')
widget_control,chbox_lbw, sensitive = 1       ;string(10B) .. novy radek
chbox_lfw=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_LFW')
widget_control,chbox_lfw, sensitive = 1       ;string(10B) .. novy radek
rbut_lfw=widget_info(Event.top, FIND_BY_UNAME='WID_RBUT_LFW')
widget_control, rbut_lfw, sensitive = 1       ;string(10B) .. novy radek
rbut_lbw=widget_info(Event.top, FIND_BY_UNAME='WID_RBUT_LBW')
widget_control, rbut_lbw, sensitive = 1       ;string(10B) .. novy radek

button = widget_info(Event.top, FIND_BY_UNAME="WID_BUTTON_13")   ;znemon pouvat tlatko Extract Current and Lockin Img
widget_control, button, sensitive = 1
button = widget_info(Event.top, FIND_BY_UNAME="WID_BUTTON_14")   ;znemon pout Get Shift
widget_control, button, sensitive = 1
button = widget_info(Event.top, FIND_BY_UNAME="WID_BUTTON_12")   ;znemon pouvat tlatko Make LDOS map
widget_control, button, sensitive = 1
button = widget_info(Event.top, FIND_BY_UNAME="WID_BUTTON_15")   ;Znemon pout taltko LDOS again
widget_control, button, sensitive = 1
ENDELSE

;*********vypis surovych dat do temp********
close, 11
openw, 11, 'temp.txt'
printf, 11, bmp
close, 11
dr, bmp, 0

;*********na zklad pednastavench kanl po probhnut procedury Open_img oteve pouze zakrtnut okna****
IF (set_channels[0] EQ 1) THEN dr, bmp_cfw, 1, "Current FW"
IF (set_channels[1] EQ 1) THEN dr, bmp_cbw, 2, "Current BW"
IF (set_channels[2] EQ 1) THEN dr, bmp_vfw, 3, "Voltage FW"
IF (set_channels[3] EQ 1) THEN dr, bmp_vbw, 4, "Voltage BW"
IF (set_channels[4] EQ 1) THEN dr, bmp_lfw, 5, "Lock-in FW"
IF (set_channels[5] EQ 1) THEN dr, bmp_lbw, 6, "Lock-in BW"

activate_window, Event  ;nate hodnotu aktivovanho okna a do bmp_cbw nate hodnotu bmp, aby bylo mon okamit exportovat do jpeg po oteven a nemuselo se na radiobutton klikat.
LABEL_STOP:        ;When pressing the STORNO button during selecting a file to open the whole procedure is being overjumped to this point.
cd, dir_main         ;nutn nastvit, aby pi zavoln Reopen program vyhledal ve sprvnm adresi idlim.prc

end

;-----------------------------------------------------------------
;-----------------------------------------------------------------
;-----------------------------------------------------------------
pro islands, Event
idlim_islands
end
;-----------------------------------------------------------------
;-----------------------------------------------------------------
;-----------------------------------------------------------------
pro REopen, Event
common filename, file
help, file

open_img, Event, /file_loaded

end

;******************************************************************
;******************************************************************
;******************************************************************
pro open_bmp, event
common data, bmp
common filename, file
common directories, dir_main, dir_templates, dir_data
common version2, ver, btempl, lockin

set_plot, 'win'

dir_main = FILE_WHICH("idlim.prc") ;nalezne hlavn soubor idlim.prc a ulo jeho cestu do promnn cur
cd, dir_main, current=dir_main              ;do promnn dir_templates ulo cestu k adresi s templates
dir_templates = dir_main+"\templates" ;do promnn dir_templates ulo cestu k adresi s templates
dir_data = dir_main+"\data"

file = dialog_pickfile(title='Select a file', filter='*.bmp')
IF (file EQ '') THEN GOTO, stop_BMP_open
selected_area=0

txt=file

text=widget_info(Event.top, FIND_BY_UNAME='WID_LABEL_0')
widget_control,text,set_value=txt[0]       ;string(10B) .. novy radek

ver='bmp'

bmp=read_bmp(file)

siz=size(bmp)
sizex=siz[1]
sizey=siz[2]
dr, bmp, 0

stop_BMP_open:
cd, dir_main
end
;******************************************************************
;******************************************************************
;******************************************************************
pro open_jpg, event
common data, bmp
common filename, file
common version2, ver, btempl, lockin
common directories, dir_main, dir_templates, dir_data

set_plot, 'win'

dir_main = FILE_WHICH("idlim.prc") ;nalezne hlavn soubor idlim.prc a ulo jeho cestu do promnn cur
cd, dir_main, current=dir_main              ;do promnn dir_templates ulo cestu k adresi s templates
dir_templates = dir_main+"\templates" ;do promnn dir_templates ulo cestu k adresi s templates
dir_data = dir_main+"\data"

filters = ['*.jpg', '*.jpeg']
file = dialog_pickfile(title='select a file', filter=filters)
IF (file EQ '') THEN GOTO, stop_open_jpg
FOR n = 1, 15 DO WDELETE, n ;uzave vechny naten kanly
selected_area=0

txt=file

text=widget_info(Event.top, FIND_BY_UNAME='WID_LABEL_0')
widget_control,text,set_value=txt[0]       ;string(10B) .. novy radek

ver='bmp'

read_jpeg, file, bmp

siz=size(bmp)
sizex=siz[1]
sizey=siz[2]
dr, bmp, 0

stop_open_jpg:

cd, dir_main

end
;******************************************************************
;******************************************************************
;******************************************************************



pro get_version
common data, bmp

common filename, file
common version2, ver, btempl, lockin
common scale, x_nm, sizex
common directories, dir_main, dir_templates
ver=''

;zjisteni verze

cd, dir_templates
restore, 'templ3_ver.dat' ;oteve template, kter zjist pouze seln kd verze souboru
print, 'file', file


velikost_souboru=N_ELEMENTS(READ_BINARY(file, DATA_START=134, DATA_TYPE=2)) ;pesko hlaviku v souboru a nate namen data do 1D pole
lockin=0; pedpokld, e v soubour nen lock-inov mapa, typ boolean

IF (velikost_souboru GT 1200000) THEN lockin = 1 ELSE lockin = 0

Bdata= Read_binary(file, template=btempl)
print, 'bdata.verze', bdata.verze

;pokud je pouit verze 70 --- F, pouije templF_ver.dat, jinak templ_ver.dat, a umon nast rozmr obrzku
if bdata.verze eq 70 then restore, 'templF_ver.dat' else restore, 'templ_ver.dat'
Bdata= Read_binary(file, template=btempl)

sizex=long(bdata.sizexy[0])
print, 'sizex ',sizex

case bdata.verze[0] of
    70: begin
         if sizex eq 512 then begin
            ver = 'F'
            IF (lockin EQ 1) THEN BEGIN;soubory bez lock-in mapy obsahuj asi 1e6 prvk, s lock-in mapou tak 1e5
                 restore, 'templ3_lockin.dat'
              ENDIF ELSE BEGIN
                 restore, 'templ3.dat'
             ENDELSE

         endif else if sizex eq 1024 then begin
            print, 'F1024'
          restore, 'templ3_1024.dat'
          ver='F'
         endif

       end

    83: begin
         if sizex eq 512 then begin
          restore, 'templ2.dat'
          ver='S'
         endif else if sizex eq 256 then begin
          restore, 'templ2_256.dat'
          ver='S'
         endif
       end

    19785 : begin
          if sizex eq 512 then begin
                   restore, 'templ1.dat'
                   ver='IMG1'
              endif else if sizex eq 256 then begin
                   restore, 'templ1_256.dat'
                   ver='IMG1'
              endif
          end

    else: ver=''
endcase
cd, dir_main
end

;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released.
;       Normal buttons do not generate events when released, so
;       SELECT will always be 1. However, toggle buttons (created by
;       parenting a button to an exclusive or non-exclusive base)
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro row_equal, Event
common channels, bmp_vfw, bmp_vbw, bmp_cfw, bmp_cbw, bmp_lfw, bmp_lbw, bmp_ldos, set_channels
common data, bmp
common lineexport, scan, lex_vfw, lex_vbw, lex_cfw, lex_cbw, lex_lfw, lex_lbw, lex_ldos

bmp=row_eq(bmp)

chbox_allc=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_ALLC')
chbox_set = widget_info(chbox_allc, /button_set)

IF (chbox_set EQ 1) THEN BEGIN
bmp_cfw=row_eq(bmp_cfw)
bmp_cbw=row_eq(bmp_cbw)
bmp_vfw=row_eq(bmp_vfw)
bmp_vbw=row_eq(bmp_vbw)
bmp_lfw=row_eq(bmp_lfw)
bmp_lbw=row_eq(bmp_lbw)

lex_cfw=row_eq(lex_cfw)
lex_cbw=row_eq(lex_cbw)
lex_vfw=row_eq(lex_vfw)
lex_vbw=row_eq(lex_vbw)
lex_lfw=row_eq(lex_lfw)
lex_lbw=row_eq(lex_lbw)
ENDIF

scan = row_eq(scan)
dr, bmp, 0
update_data, bmp
update_lex, scan
end
;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released.
;       Normal buttons do not generate events when released, so
;       SELECT will always be 1. However, toggle buttons (created by
;       parenting a button to an exclusive or non-exclusive base)
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro plain_subst, Event
common data, bmp
common channels, bmp_vfw, bmp_vbw, bmp_cfw, bmp_cbw, bmp_lfw, bmp_lbw, bmp_ldos, set_channels
common lineexport, scan, lex_vfw, lex_vbw, lex_cfw, lex_cbw, lex_lfw, lex_lbw, lex_ldos

chbox_allc=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_ALLC')
chbox_set = widget_info(chbox_allc, /button_set)

IF (chbox_set EQ 1) THEN BEGIN
bmp_cfw=plain_sub(bmp_cfw)
bmp_cbw=plain_sub(bmp_cbw)
bmp_vfw=plain_sub(bmp_vfw)
bmp_vbw=plain_sub(bmp_vbw)
bmp_lfw=plain_sub(bmp_lfw)
bmp_lbw=plain_sub(bmp_lbw)

lex_cfw=plain_sub(lex_cfw)
lex_cbw=plain_sub(lex_cbw)
lex_vfw=plain_sub(lex_vfw)
lex_vbw=plain_sub(lex_vbw)
lex_lfw=plain_sub(lex_lfw)
lex_lbw=plain_sub(lex_lbw)
ENDIF

bmp=plain_sub(bmp)
scan = plain_sub(scan)
dr, bmp, 0
update_data, bmp
update_lex, scan
end
;-----------------------------------------------------------------
pro plain_subst_area, Event
common data, bmp
common channels, bmp_vfw, bmp_vbw, bmp_cfw, bmp_cbw, bmp_lfw, bmp_lbw, bmp_ldos, set_channels
common lineexport, scan, lex_vfw, lex_vbw, lex_cfw, lex_cbw, lex_lfw, lex_lbw, lex_ldos

x=select_area(10)

chbox_allc=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_ALLC')
chbox_set = widget_info(chbox_allc, /button_set)
IF (chbox_set EQ 1) THEN BEGIN
bmp_cfw=plain_sub_area(bmp_cfw,x)
bmp_cbw=plain_sub_area(bmp_cbw,x)
bmp_vfw=plain_sub_area(bmp_vfw,x)
bmp_vbw=plain_sub_area(bmp_vbw,x)
bmp_lfw=plain_sub_area(bmp_lfw,x)
bmp_lbw=plain_sub_area(bmp_lbw,x)

lex_cfw=plain_sub_area(lex_cfw, x)
lex_cbw=plain_sub_area(lex_cbw, x)
lex_vfw=plain_sub_area(lex_vfw, x)
lex_vbw=plain_sub_area(lex_vbw, x)
lex_lfw=plain_sub_area(lex_lfw, x)
lex_lbw=plain_sub_area(lex_lbw, x)
ENDIF

bmp=plain_sub_area(bmp,x)
scan = plain_sub_area(scan,x)
dr, bmp, 0
update_data, bmp
update_lex, scan
end
;-----------------------------------------------------------------
pro export_jpeg, Event
common data, bmp
common filename, file
ff=file

strput, ff, 'jpg', strlen(ff)-3
wset,0
ex_jpeg, ff, Event
end
;-----------------------------------------------------------------
pro ex_line_profile, Event
common line, line, linex, liney, x_A, x_B
common data, bmp
common filename, file
common scale, x_nm, sizex, step_xy, const_z
common directories, dir_main, dir_templates, dir_data
common active_window, active_window

eximg = ""
case active_window  of
    1: eximg = "Current FW"
    2: eximg = "Current BW"
    3: eximg = "Voltage FW"
    4: eximg = "Voltage BW"
    5: eximg = "Lock-in FW"
    6: eximg = "Lock-in BW"
    7: eximg = "LDOS Map"
endcase

 siz=size(bmp)
 sizex=siz[1]
 sizey=siz[2]


linefile = dialog_pickfile(title='select a file', /write)
IF (linefile EQ '') THEN GOTO, stop_ex_line_profile

;   siz=size(bmp[*,y],/N_ELEMENTS) ;poet prvk v y-tm dku
;lineex=intarr(2,siz)    ;2D pole typu size * 2
;lineex[0,*]=indgen(siz) ;prvn st pole dostane hodnoty 0...siz
;lineex[1,*]=bmp[*,y]    ;druh st pole zsk hodnoty v dku
;close, 1
IF ((active_window EQ 3) or (active_window EQ 4)) THEN BEGIN
    z_axis = "z [nm]"
ENDIF ELSE BEGIN
    z_axis = "arbitary units"
ENDELSE

openw, 1, linefile
;printf, 1, bmp[*,y]
;print, 1, FORMAT = '(I10,I10)',  INDGEN(512), bmp[*,y]
printf, 1, 'Line profile between the points A and B'
printf, 1, eximg
printf, 1, 'File: ', file , string(9b)
printf, 1, 'Start and end point coordinates in pixels [x, y]:'
Acoor = string(x_A[0])+", "+string(x_A[1])
Bcoor = string(x_B[0])+', '+string(x_B[1])
printf, 1, "A: ", Acoor
printf, 1, "B: ", Bcoor
printf, 1, string(9b), 'x [nm]',string(9b), string(9b), z_axis,string(9b)

printf, 1, line
close, 1
stop_ex_line_profile: ;Aby program nespadnul, kdy se pi vbru souboru k uloen klikne na storno
cd, dir_main

end
;-----------------------------------------------------------------

; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released.
;       Normal buttons do not generate events when released, so
;       SELECT will always be 1. However, toggle buttons (created by
;       parenting a button to an exclusive or non-exclusive base)
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)


;-----------------------------------------------------------------
pro hist_eq, Event
common data, bmp
common channels, bmp_vfw, bmp_vbw, bmp_cfw, bmp_cbw, bmp_lfw, bmp_lbw, bmp_ldos, set_channels
common version2, ver, btempl, lockin ;zjist  naten lock-inu

chbox_allc=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_ALLC')
chbox_set = widget_info(chbox_allc, /button_set)

    IF (chbox_set EQ 1) THEN BEGIN   ;pokud je zvolena monos All channels, bude toto pouito na vechny kanl
    hist_eq_en, 0,255, bmp_cfw
    bmp_cfw=tvrd()
    ij=enhance_contrast(bmp_cfw)
    print,'ij[0], ij[1]',ij[0], ij[1]
    hist_eq_en, ij[0], ij[1], bmp_cfw
    WSET, 0
    bmp_cfw = TVRD()

    hist_eq_en, 0,255, bmp_cbw
    bmp_cbw=tvrd()
    ij=enhance_contrast(bmp_cbw)
    print,'ij[0], ij[1]',ij[0], ij[1]
    hist_eq_en, ij[0], ij[1], bmp_cbw
    WSET, 0
    bmp_cbw = TVRD()

    hist_eq_en, 0,255, bmp_vfw
    bmp_vfw=tvrd()
    ij=enhance_contrast(bmp_vfw)
    print,'ij[0], ij[1]',ij[0], ij[1]
    hist_eq_en, ij[0], ij[1], bmp_vfw
    WSET, 0
    bmp_vfw = TVRD()

    hist_eq_en, 0,255, bmp_vbw
    bmp_vbw=tvrd()
    ij=enhance_contrast(bmp_vbw)
    print,'ij[0], ij[1]',ij[0], ij[1]
    hist_eq_en, ij[0], ij[1], bmp_vbw
    WSET, 0
    bmp_vbw = TVRD()

       IF (lockin=1) THEN BEGIN
        hist_eq_en, 0,255, bmp_lfw
        bmp_lfw=tvrd()
        ij=enhance_contrast(bmp_lfw)
        print,'ij[0], ij[1]',ij[0], ij[1]
        hist_eq_en, ij[0], ij[1], bmp_lfw
        WSET, 0
        bmp_lfw = TVRD()

        hist_eq_en, 0,255, bmp_lbw
        bmp_lbw=tvrd()
        ij=enhance_contrast(bmp_lbw)
        print,'ij[0], ij[1]',ij[0], ij[1]
        hist_eq_en, ij[0], ij[1], bmp_lbw
        WSET, 0
        bmp_lbw = TVRD()
        ENDIF
    ENDIF

hist_eq_en, 0, 255, bmp
bmp=tvrd()  ;z okna s hodnotou 0 (na monitoru jako
ij=enhance_contrast(bmp)
print,'ij[0], ij[1]',ij[0], ij[1]
hist_eq_en, ij[0], ij[1], bmp
WSET, 0
bmp = TVRD()

plot_hist, bmp
update_data, bmp
;temp=where(bmp gt 254, count)
;print, count
;dr, HIST_EQUAL(bmp, minv=0, maxv=255), 0
end

;-----------------------------------------------------------------
pro hist_eq_en, a, b, data
 ;---nate velikost dat---;
 siz=size(data)
 sizex=siz[1]
 sizey=siz[2]

;text=widget_info(Event.top, FIND_BY_UNAME='WID_SLIDER_0')
;widget_control,text,set_value=a
;text=widget_info(Event.top, FIND_BY_UNAME='WID_SLIDER_1')
;widget_control,text,set_value=b

 new=data   ;vytvo novou promnnou new

;new=HIST_EQUAL(bmp);, minv=0, maxv=255)
;print, 'min', min(new)
;print, 'max', max(new)
;new=255.0*(new-a)/(b-a)

new=255*(float(new)-min(new))/(max(new)-min(new))-1 ;Chov se jako procedura tvscl --- promnn new je nyn peklovna v rozpt hodnot 0---255
new=255*(float(new)-a)/(b-a)-1  ;Pekluje promnnou new podle hodnot a, b

index = WHERE(new lt 0, count)  ;v poli new zjist indexy, kde hodnoty jsou men ne 0
if count ne 0 then new[where(new lt 0)]=0 ;pro tyto indexy nastav hodnotu 0
index = WHERE(new gt 255, count)  ;v poli new zjist indexy, kde hodnoty jsou vt ne 255
if count ne 0 then new[where(new gt 255)]=255    ;tyto hodnoty nahrad 255

dr, new, 0
update_data, new
end

;-----------------------------------------------------------------
pro get_val_plain_subst, Event
common data, bmp
selected_area=~ selected_area
end

;-----------------------------------------------------------------
pro process, Event
common data, bmp
common version2, ver, btempl, lockin
common filename, file
common directories, dir_main, dir_templates, dir_data

files=DIALOG_PICKFILE(/multiple_files, filter='*.img')  ;vznikne pole s nzvy soubor
;IF (files EQ '') THEN GOTO, stop_process

siz=size(files)
number=siz[1]   ;poet souboru
file=files[0]

;restore, '/templates/templ1.dat'
text=widget_info(Event.top, FIND_BY_UNAME='WID_TEXT_channel')   ;lut
widget_control,text,get_value=channel

FOR counter=0, number-1 do begin
    file=files[counter]
    get_version
  Bdata= Read_binary(files[counter], template=btempl);, data_Start=0, data_dims=1000)

if ver eq 'F' then begin
    voltage_fw=bdata.voltage_fw
    voltage_bw=bdata.voltage_bw
    current_fw=bdata.current_fw
    current_bw=bdata.current_bw
endif else begin
    voltage_fw=bdata.voltage
    voltage_bw=bdata.voltage
    current_fw=bdata.current
    current_bw=bdata.current
endelse


case ver of
  'IMG1': begin
         BMP=(bdata.ar[*,*,channel])    ;0...current image 1...z image
         bmp=reverse(bmp,2)
       end
  'S'   : begin
           BMP=(bdata.ar[*,*,channel])  ;0,1...current image 2,3...z image
           bmp=reverse(reverse(bmp,2))
          end
  'F'   : begin
         bmp_cfw=(bdata.ar[*,*,0])  ;nate postupn jednotliv kanly cfw.. current_forward atd.
         bmp_cbw=(bdata.ar[*,*,1])
         bmp_vfw=(bdata.ar[*,*,2])
         bmp_vbw=(bdata.ar[*,*,3])

        bmp_cfw = reverse(bmp_cfw,2)
        bmp_cbw = reverse(reverse(bmp_cbw,2))
        bmp_vfw = reverse(bmp_vfw,2)
        bmp_vbw = reverse(reverse(bmp_vbw,2))
         IF (lockin EQ 1) THEN BEGIN
            bmp_lfw = (bdata.ar[*,*,4])
            bmp_lfw = reverse(bmp_lfw,2)    ;pravdpodobn nutn stejnm zpsobem pevrtit lockin
            bmp_lbw = (bdata.ar[*,*,5])
            bmp_lbw = reverse(reverse(bmp_lbw,2))
            bmp_b = bmp_lfw
            bmp_a = bmp_cfw
         ENDIF  ELSE BEGIN  ;pokud nen lockinov signl, vytvo przdn pole
            bmp_lfw=INTARR(512,512)
            bmp_lbw=INTARR(512,512)
         ENDELSE
           BMP=(bdata.ar[*,*,channel])  ;0,1...current image 2,3...z image
           BMP = reverse(reverse(bmp,2))
       end

  else  : begin
         res=DIALOG_MESSAGE('unknown file format')
         BMP=intarr(128,128)*0
       end
endcase

if channel eq '0' or channel eq '2' then bmp=reverse(bmp)

    txt=''+files[counter]+string(10B)
    txt=txt+'img version:'+ string(ver)+string(10B)
    txt=txt+'resolution:'+ string(bdata.sizexy)+string(10B)
    txt=txt+'date:'+ string(fix(bdata.day))+ '.'+string(fix(bdata.mon))+'.'+ string(bdata.year)+string(10B)+'time:'+ string(fix(bdata.hour))+':'+string(fix(bdata.mins))+':'+string(fix(bdata.sec))+string(10B)
    txt=txt+'voltage fw:'+string(voltage_fw)+string(10B)+'voltage bw:'+string(voltage_bw)+string(10B)+ 'current fw:'+ string(current_fw)+string(10B)+ 'current bw:'+ string(current_bw)+string(10B)
    txt=txt+'scan speed: '+ string(bdata.scan_speed) +string(10B)+'x offset:'+ string(bdata.xof) +string(10B)+ 'y offset:'+ string(bdata.yof)+string(10B)
    txt=txt+'size: '+ string(bdata.sizexy*bdata.step_xy)+string(10B)+'*************************************'

x_nm=bdata.sizexy*bdata.step_xy

;help, txt
;text=widget_info(Event.top, FIND_BY_UNAME='WID_LABEL_0')
;widget_control,text,set_value=txt[0]     ;string(10B) .. novy radek
print, txt[0]

logfile=strmid(files[counter], 0,  strlen(files[counter])-7)+'_log.txt'
openw, 10, logfile, /append
    printf, 10, txt[0]
close, 10



;  BMP=(bdata.ar[*,*,1])    ;0...current image 1...z image
  ;bmp=2^13*(bmp-min(bmp))/(max(bmp)-min(bmp))
  siz=size(bmp)
  sizex=siz[1]
  sizey=siz[2]

text=widget_info(Event.top, FIND_BY_UNAME='WID_TEXT_orez')   ;lut
widget_control,text,get_value=ram

;ram=0  ;pripadny orez
bmp=bmp[ram:sizex-ram-1, 0:sizey-ram-1]
siz=size(bmp)
sizex=siz[1]
sizey=siz[2]


  bmp=row_eq(bmp)
  bmp=plain_sub(bmp)


;   ;hist_eq_en, 0,255
hist_eq_en, 0,200, bmp
bmp=tvrd()
ij=enhance_contrast(bmp)
;print,'ij[0], ij[1]',ij[0], ij[1]
hist_eq_en, ij[0], ij[1], bmp


;  ;dr, bmp,1;HIST_EQUAL(BMP),1
  wset, 0
  ex_jpeg, files[counter], Event
endfor

stop_process:
cd, dir_main
end

;-----------------------------------------------------------------
pro zoom_image, Event
text=widget_info(Event.top, FIND_BY_UNAME='WID_TEXT_ZOOM')   ;rozmery okna
widget_control,text,get_value=zoom_fact
my_zoom, /CONTINUOUS, fact=zoom_fact, /keep

end

;-----------------------------------------------------------------
pro export_im, Event
common filename, file
print, file
wset, 0
t=tvrd()

jpeg_file=file
strput, jpeg_file, 'jpg', strlen(jpeg_file)-3
if strmid(jpeg_file, strlen(jpeg_file)-6, 1) eq '_' then begin
    jpeg_file=strmid(jpeg_file, 0, strlen(jpeg_file)-5)+'00'+strmid(jpeg_file, strlen(jpeg_file)-5, 5)
endif
if strmid(jpeg_file, strlen(jpeg_file)-7, 1) eq '_' then begin
    jpeg_file=strmid(jpeg_file, 0, strlen(jpeg_file)-6)+'0'+strmid(jpeg_file, strlen(jpeg_file)-6, 6)
endif


res=DIALOG_WRITE_IMAGE(t, /WARN_EXIST, file=jpeg_file);, dir=jpeg_file)
;write_jpeg, jpeg_file, t
;print, jpeg_file
end

;-----------------------------------------------------------------            +++
pro slider, Event
common data, bmp
common channels, bmp_vfw, bmp_vbw, bmp_cfw, bmp_cbw, bmp_lfw, bmp_lbw, bmp_ldos, set_channels


text=widget_info(Event.top, FIND_BY_UNAME='WID_SLIDER_0')   ;rozmery okna
widget_control,text,get_value=min_hist

text=widget_info(Event.top, FIND_BY_UNAME='WID_SLIDER_1')   ;rozmery okna
widget_control,text,get_value=max_hist

hist_eq_en, min_hist, max_hist, bmp
;bmp=tvrd()
update_data, bmp

end
;-----------------------------------------------------------------

pro line_profile, Event
common data, bmp
common line, line, linex, liney, x_A, x_B
common scale, x_nm, sizex, step_xy, const_z
common curr, current_fw
common active_window, active_window
common lineexport, scan ;needed to export line in proper units

 siz=size(bmp)
 sizex=siz[1]
 sizey=siz[2]

;**********nate zvolen polohy*********
wset, 0
cursor, x0, y0, /down, /normal
x1=long(fix(x0*sizex))
y1=long(fix(y0*sizey))
print, "x1,y1", x1,y1
x_A = [x1, y1]

cursor, x0, y0, /down, /normal
x2=long(fix(x0*sizex))
y2=long(fix(y0*sizey))
print, "x2,y2", x2,y2
x_B = [x2, y2]

points=fix(sqrt((x2-x1)^2+(y2-y1)^2)) ;vzdlenost vybranch bod v pixlech
print, points
i_arr=indgen(points)
tempbmp=tvrd()  ;nate hodnoty zobrazenho okna IDL 0
tempbmp[fix(x1+(x2-x1)*i_arr/points), fix(y1+(y2-y1)*i_arr/points)]=0 ;v poli tempbmp vytov seku X1Y1 --- X2Y2 s hodnotami 0
tv, tempbmp ;vykresl msto, kudy vede ra

liney= scan[fix(x1+(x2-x1)*i_arr/points), fix(y1+(y2-y1)*i_arr/points)]
liney= liney*const_z
linex = i_arr*step_xy

;**********

print, fix(x1+(x2-x1)*i_arr/points), fix(y1+(y2-y1)*i_arr/points)
;print, "line", line
;line=tvrd(0,y,sizey-1,1)
;line=bmp(*,y)
;line=bmp(*,257)
window, 10, title = "Line Profile"

;print, line
IF ((active_window EQ 3) or (active_window EQ 4)) THEN BEGIN
plot, linex, liney, xtitle="[nm]", ytitle="z [nm]"
ENDIF ELSE BEGIN
plot, linex, liney, xtitle="[nm]", ytitle="arbitary units"
ENDELSE
line = MAKE_ARRAY(2,points, /double)
line[0,*] = linex
line[1,*] = liney
print, "aktivn okno", active_window
end


;*****************************************************************************************
;***************************dr************************************************************
;*****************************************************************************************
pro dr, b, kam, win_title, Event
common lutblock, set_lut
common version2, ver, btempl, lockin
;common version2, ver, btempl
common lutno, lut_fact

;print, 'if lut', if_lut                   ;*lut*
print, 'set_lut v dr',set_lut
siz=size(b)
sizex=siz[1]
sizey=siz[2]
window, kam, xsize=sizex, ysize=sizey, title=win_title

DEVICE, DECOMPOSED = 0
if set_lut then begin
 RR = INDGEN(256)*0
 GG = INDGEN(256)*0
 BB = INDGEN(256)*0

redlimit=85                     ;85
greenlimit=170

 RR[0:redlimit]=RR[0:redlimit]*256/redlimit
 RR[redlimit+1:255]=255
 GG[redlimit+1:greenlimit]=indgen(greenlimit-redlimit)*256/(greenlimit-redlimit)
 GG[greenlimit+1:255]=255
 BB[greenlimit+1:255]=indgen(255-greenlimit)*256/(255-greenlimit)
TVLCT, RR, GG, BB

;text=widget_info(Event.top, FIND_BY_UNAME='WID_TEXT_ZOOM')   ;lut
;widget_control,text,get_value=lut_fact
loadct, lut_fact

endif else begin
  RR = INDGEN(256)
  GG = INDGEN(256)
  BB = INDGEN(256)
 TVLCT, RR, GG, BB
endelse


tvscl, b
;tv, b

;if (ver eq 'IMG1' or ver eq 'S') then add_scale
;wshow, kam, show

return
end



;*****************************************************************************************
;*************************add_scale*******************************************************  xxx
;*****************************************************************************************

pro add_scale
common scale, x_nm, sizex

length=fix(x_nm[0]/5)*sizex/x_nm[0]
;print, 0.5+length/sizex

plots, [0.75,0.05],/normal
plots, [0.75+length/sizex,0.05],/normal, /continue
str= string(FORMAT = '(I2)', fix(x_nm[0]/5))+' nm'
xyouts, 0.75+0.5*length/sizex,0.06, str, /normal, alignment=0.5, color=255
end



;*****************************************************************************************
;*************************ex_jpeg*********************************************************
;*****************************************************************************************
pro ex_jpeg, name, Event
common lutblock, set_lut
jpeg_file=name

text=widget_info(Event.top, FIND_BY_UNAME='WID_TEXT_channel')   ;lut
widget_control,text,get_value=channel
channel = fix(channel)
case channel of
    '2': chan='fwz'
    '3': chan='bwz'
    '0': chan='fwI'
    '1': chan='bwI'
    else: chan=''
endcase

if set_lut then t=tvrd(true=1) else t=tvrd()
strput, jpeg_file, 'jpg', strlen(jpeg_file)-3
if strmid(jpeg_file, strlen(jpeg_file)-6, 1) eq '_' then begin
    jpeg_file=strmid(jpeg_file, 0, strlen(jpeg_file)-5)+'00'+strmid(jpeg_file, strlen(jpeg_file)-5, 5)
endif
if strmid(jpeg_file, strlen(jpeg_file)-7, 1) eq '_' then begin
    jpeg_file=strmid(jpeg_file, 0, strlen(jpeg_file)-6)+'0'+strmid(jpeg_file, strlen(jpeg_file)-6, 6)
endif
jpeg_file=strmid(jpeg_file, 0, strlen(jpeg_file)-4)+chan+strmid(jpeg_file, strlen(jpeg_file)-4, strlen(jpeg_file))

;res=DIALOG_WRITE_IMAGE(t, /WARN_EXIST)
if set_lut then write_jpeg, jpeg_file, t, true=1 else write_jpeg, jpeg_file, t
print, jpeg_file
end
;-----------------------------------------------------------------
pro export_jpeg, Event
;common data, bmp

file = dialog_pickfile(/WRITE, FILTER = '*.jpg',PATH='c:')
IF (file EQ '') THEN GOTO, stop_export_jpeg
file = file+".jpg"
wset, 0
bmp = TVRD()
write_jpeg, file, bmp
stop_export_jpeg:
end
;#################################################################

pro ExtractLDOSImages, Event
common channels, bmp_vfw, bmp_vbw, bmp_cfw, bmp_cbw, bmp_lfw, bmp_lbw, bmp_ldos, set_channels
common data, bmp
;common data1, bmp_a,bmp_b
common data2, aa,bb
common curr,current_fw
siz=size(bmp_cfw)
sizex=siz[1]
sizey=siz[2]

aa=intarr(sizex,sizey)
bb=aa
cc=bb
;aa=bmp_a
;bb=bmp_b
bmp_cfw=plain_sub(bmp_cfw)
bmp_lfw=plain_sub(bmp_lfw)
;bmp_a=row_eq(bmp_a)
;bmp_b=row_eq(bmp_b)
bmp_cfw=smooth(bmp_cfw,5)
bmp_lfw=smooth(bmp_lfw,5)

mina=min(bmp_cfw)
maxa=max(bmp_cfw)
minb=min(bmp_lfw)
maxb=max(bmp_lfw)

print, mina, maxa, minb, maxb


aa=(float(bmp_cfw)-mina)/(float(maxa)-mina)*255.0
bb=(float(bmp_lfw)-minb)/(float(maxb)-minb)*255.0
aa=row_eq(aa)
bb=row_eq(bb)
;a=enhance_contrast(aa)
;b=enhance_contrast(bb)
;print,a

;print,b

;aa=float(bmp_a-a[0])/(a[1]-a[0])*255.0
;bb=float(bmp_b-b[0])/(b[1]-b[0])*255.0

;aa[where(aa lt 0 )]=0
;aa[where(aa gt 255)]=255
;bb[where(bb lt 0 )]=0
;bb[where (bb gt 255)]=255
siz=size(aa)
sizex=siz[1]
sizey=siz[2]

window, 8, xsize=sizex, ysize=sizey, title="Current Image"
tvscl, aa
siz=size(bb)
sizex=siz[1]
sizey=siz[2]
window, 9, xsize=sizex, ysize=sizey, title="Lock-in Image"
tvscl, bb

end

;-----------------------------------------------------------------
pro GetShift, Event
common data, bmp
common data1, bmp_a,bmp_b
common data2, aa,bb
common shift, posx, posy
common curr,current_fw

fromDFT=FFT2dcorr(aa, bb)
posx=fromDFT[0]
posy=fromDFT[1]
print,'***', posx, posy

text=widget_info(Event.top, FIND_BY_UNAME='WID_TEXT_POSX')
widget_control,text,set_value=string(posx)

text=widget_info(Event.top, FIND_BY_UNAME='WID_TEXT_POSY')
widget_control,text,set_value=string(posy)

end
;-----------------------------------------------------------------
pro MakeLDOS, Event
common channels, bmp_vfw, bmp_vbw, bmp_cfw, bmp_cbw, bmp_lfw, bmp_lbw, bmp_ldos, set_channels
common data, bmp
common data1, bmp_a, bmp_b
common data2, aa, bb
common shift,posx, posy
common curr,current_fw
common minmax, minm, maxm

print, 'LDOS'


text=widget_info(Event.top, FIND_BY_UNAME='WID_TEXT_POSX')   ;lut
widget_control,text,get_value=posx

text=widget_info(Event.top, FIND_BY_UNAME='WID_TEXT_POSY')   ;lut
widget_control,text,get_value=posy

sizeb=size(bmp_cfw)
print, "velikost pole bmp_cfw", sizeb[0], sizeb[1]

print,'***', posx, posy
map=FltArr(512,512)
FOR i=0,511 DO BEGIN
   FOR j=0,511 DO BEGIN
       k=(i-posx+512) mod 512
       l=(j-posy+512) mod 512
       ;map[i,j]=float(bmp_b[k,l])/float(abs(float(bmp_a[i,j])+3276.8*current_fw))
       map[i,j]=float(bmp_b[k,l])/float(abs(float(bmp_a[i,j])+3276.8*current_fw))
   ENDFOR
ENDFOR

map=smooth(map,5)
;map[where(map gt 40)] =40
;map[where(map lt -20)]=-20
minm=min(map)
maxm=max(map)

text=widget_info(Event.top, FIND_BY_UNAME='WID_TEXT_MINM')
widget_control,text,set_value=string(minm)

text=widget_info(Event.top, FIND_BY_UNAME='WID_TEXT_MAXM')
widget_control,text,set_value=string(maxm)

bmp_ldos=fix((float(map)-minm)/(float(maxm)-minm)*255.0)
bmp_ldos=row_eq(bmp_ldos)
print, minm, maxm
;print, map[256,*]
text=widget_info(Event.top, FIND_BY_UNAME='WID_TEXT_orez')   ;lut ;zjist velikost nastavenho oezu a ped jej do procedury oez
widget_control,text,get_value=orez

Orez_okraju, bmp_ldos, orez
siz=size(bmp_ldos)
sizex=siz[1]
sizey=siz[2]
window, 7, xsize=sizex, ysize=sizey, title='LDOS Map'
tvscl, bmp_ldos ;procedura tvscl normalizuje data bmp_ldos a zobraz je v rozpt 0---255
bmp_ldos=tvrd() ;tvrd() sejme data vytvoen procedurou tvscl z monitoru a ulo je zpt do bmp_ldos

button = widget_info(Event.top, FIND_BY_UNAME="WID_CHBOX_LDOS")   ;Znemon pout taltko LDOS again
widget_control, button, sensitive = 1
widget_control, button, /set_button
button = widget_info(Event.top, FIND_BY_UNAME="WID_RBUT_LDOS")   ;Znemon pout taltko LDOS again
widget_control, button, sensitive = 1
widget_control, button, /set_button
widget_control, button, /set_button
bmp=bmp_ldos
wdelete, 8
wdelete, 9
end

;###################################################################

pro MakeLDOSAgain, Event
common data, bmp
common data1, bmp_a,bmp_b
common data2, aa,bb
common shift,posx, posy
common curr,current_fw
common minmax, minm,maxm

print, 'LDOS Again'


text=widget_info(Event.top, FIND_BY_UNAME='WID_TEXT_POSX')   ;lut
widget_control,text,get_value=posx

text=widget_info(Event.top, FIND_BY_UNAME='WID_TEXT_POSY')   ;lut
widget_control,text,get_value=posy

text=widget_info(Event.top, FIND_BY_UNAME='WID_TEXT_MINM')   ;lut
widget_control,text,get_value=minm

text=widget_info(Event.top, FIND_BY_UNAME='WID_TEXT_MAXM')   ;lut
widget_control,text,get_value=maxm

print,'***', posx, posy

print,minm, maxm
Map=FltArr(512,512)
FOR i=0,511 DO BEGIN
   FOR j=0,511 DO BEGIN
       k=(i-posx+512) mod 512
       l=(j-posy+512) mod 512
       map[i,j]=float(bmp_b[k,l])/float(abs(float(bmp_a[i,j])+3276.8*current_fw))
       ;       map[i,j]=float(bmp_b[k,l])/float(abs(current_fw))
       if map[i,j] gt maxm then map[i,j]=maxm
       if map[i,j] lt minm then map[i,j]=minm
   ENDFOR
ENDFOR

;map=smooth(map,5)
;count=0
;index = WHERE(map gt maxm, count)
;print ,index,' '
;if count ne 0 then map[where(map gt maxm)]=maxm
;count=0
;;index = WHERE(map lt minm, count)
;print, index
;if count ne 0 then map[where(map lt minm)]=minm

;map[where(map gt maxm)]=maxm
;map[where(map lt minm)]=minm
minm=min(map)
maxm=max(map)

bmp=fix((float(map)-minm)/(float(maxm)-minm)*255.0)
;bmp=row_eq(bmp)
print,minm, maxm
print, map[256,*]
siz=size(bmp)
sizex=siz[1]
sizey=siz[2]
window, 7, xsize=sizex, ysize=sizey, title="LDOS Map"
tvscl, bmp
update_data, bmp
end

;###################################################################
function FFT2dcorr, a, b

;spocita posun dvou obrazku z maxima korelacni funkce
;a,b... 2D pole
sizea=size(a)
sizex=sizea[1]
sizey=sizea[2]
big_a=intarr(2*sizex, 2*sizey)
          ; dodefinovani do dvojnasobneho pole
big_b=big_a
big_a(0:sizex-1, 0:sizey-1)=a
big_b(sizex:2*sizex-1, sizey:2*sizey-1)=b
print,'corr start'
foura=FFT(big_a, -1)
print,'FFT1'
                 ; fft tam
fourb=FFT(big_b, -1)
print,'FFT2'

four_cor=foura*reverse(reverse(fourb,2))    ; prenasobeni

cor=FFT(four_cor, 1)                 ; fft zpet
;window, 2, xsize=512, ysize=512
;tvscl,cor
print,'Corr ready'

res= max(abs(cor), maximum)

x_max=(maximum mod (2*sizex))-sizex
y_max=(maximum/(2*sizey))-sizey
print, x_max, y_max
return, [x_max, y_max]

end
;###################################################################
;-----------------------------------------------------------------
pro fft2, Event
common data, bmp
;common share1, jpeg, sizex, sizey
common share2, mixed_FFT

siz=size(bmp)
sizex=siz[1]
sizey=siz[2]
jpeg=bmp

window, 15, xsize=sizex, ysize=sizey, title = "Fourier Transform"
FFT2d=fft(plain_sub(row_eq(jpeg)), -1)
mixed_FFT=mix(FFT2d)

;text=widget_info(Event.top, FIND_BY_UNAME='WID_TEXT_0')
;widget_control,text,get_value=brightness
brightness=100

tv, abs(mixed_FFT)*brightness[0]
;print, brightness[0]

;text=widget_info(Event.top, FIND_BY_UNAME='x_size_window')   ;rozmery okna
;widget_control,text,get_value=x_size_window
;text=widget_info(Event.top, FIND_BY_UNAME='y_size_window')   ;rozmery okna
;widget_control,text,get_value=y_size_window

end


;-----------------------------------------------------------------
;-----------------------------------------------------------------
;-----------------------------------------------------------------
pro inverse_FFT_2d, Event
common share1, jpeg, sizex, sizey
common share2, mixed_FFT
common share_2dfiltered, filtred_jpeg

sizejpeg=size(mixed_FFT)
sizex=sizejpeg(1)
sizey=sizejpeg(2)

;text=widget_info(Event.top, FIND_BY_UNAME='x_size_window')   ;rozmery okna
;widget_control,text,get_value=x_size_window
;text=widget_info(Event.top, FIND_BY_UNAME='y_size_window')   ;rozmery okna
;widget_control,text,get_value=y_size_window

;message, 'select bottom left corner of window', /informational

wset, 15
cursor, x0,y0,/down, /norm
x0=fix(sizex*x0)
y0=fix(sizey*y0)

x_size_window=sizex-(x0*2)
y_size_window=sizey-(y0*2)

x=0.5*x_size_window/sizex
y=0.5*y_size_window/sizey


PLOTS, [0.5-x, 0.5-y], /normal              ;nakresli okno pro fft filtr
PLOTS, [0.5-x, 0.5+y], /continue, /normal
PLOTS, [0.5+x, 0.5+y], /continue, /normal
PLOTS, [0.5+x, 0.5-y], /continue, /normal
PLOTS, [0.5-x, 0.5-y], /continue, /normal


x=fix(sizex/2)                                ;aplikace filtru
y=fix(sizey/2)

;xw=fix(x_size_window[0]/2)
;yw=fix(y_size_window[0]/2)

xw=fix(x_size_window/2)
yw=fix(y_size_window/2)


filtered_mixed_FFT=mixed_FFT*0
filtered_mixed_FFT(x-xw:x+xw-1, y-yw:y+yw-1)=mixed_FFT(x-xw:x+xw-1, y-yw:y+yw-1)

filtred_jpeg=FFT(filtered_mixed_FFT, 1)                  ;FFT zpet

window, 16, xsize=sizex, ysize=sizey, title="Inverse Fourier Transform"
;wset, 2
tvscl, hist_equal(abs(filtred_jpeg))


end



pro lut, event
common data, bmp
common lutblock, set_lut
common lutno, lut_fact
set_lut= ~set_lut
;print, 'set_lut', set_lut
text=widget_info(Event.top, FIND_BY_UNAME='WID_TEXT_lut')   ;lut
widget_control,text,get_value=lut_fact
print, 'lut::', lut_fact
dr, bmp, 0

end

pro lut_ini, Event
common lutblock, set_lut
set_lut=0
;print, 'set_lut ',set_lut

end


;**********************************************************
pro plot_hist, b
window, 10, title="Intensity Histogram of The Selected Window"
ar=indgen(512)  ;vektor o potu 512 prvk s hodnotami postupn 0---511
count=intarr(512) ;vektor o potu 512 prvk s hodnotami 0

for i=0, 511 do begin
temp=where(fix(b) eq ar[i], co)     ;co = poet prvk v poli b, je spluj podmnku
count[i]=co
endfor

plot, ar, count     ;vykresl graf, osa x = ar, count = osa y
wset, 0
end;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released.
;       Normal buttons do not generate events when released, so
;       SELECT will always be 1. However, toggle buttons (created by
;       parenting a button to an exclusive or non-exclusive base)
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro open_jpeg, Event

end
;-----------------------------------------------------------------
; Notify Realize Callback Procedure.
; Argument:
;   wWidget - ID number of specific widget.
;
;
;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------

;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released.
;       Normal buttons do not generate events when released, so
;       SELECT will always be 1. However, toggle buttons (created by
;       parenting a button to an exclusive or non-exclusive base)
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
;-----------------------------------------------------------------
;-----------------------------------------------------------------
PRO Orez_okraju, bitmapa, orez

siz=size(bitmapa)
sizex=siz[1]
sizey=siz[2]

bitmapa=bitmapa[orez:sizex-orez-1, orez:sizey-orez-1]
help, bmp
siz=size(bitmapa)
sizex=siz[1]
sizey=siz[2]
END

;************************************************************************;
;**************** procedury pro zobrazovn zvolench kanl*************;
;************************************************************************;
pro window_vfw, Event
common channels, bmp_vfw, bmp_vbw, bmp_cfw, bmp_cbw, bmp_lfw, bmp_lbw, bmp_ldos, set_channels

chbox_vfw=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_VFW')
chbox_set = widget_info(chbox_vfw, /button_set)

IF (chbox_set EQ 1) THEN BEGIN
dr, bmp_vfw, 2, "Voltage FW"

ENDIF ELSE BEGIN
wdelete, 2
ENDELSE

end

pro window_vbw, Event
common channels, bmp_vfw, bmp_vbw, bmp_cfw, bmp_cbw, bmp_lfw, bmp_lbw, bmp_ldos, set_channels

chbox_vbw=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_VBW')
chbox_set = widget_info(chbox_vbw, /button_set)

IF (chbox_set EQ 1) THEN BEGIN
dr, bmp_vbw, 3, "Voltage BW"

ENDIF ELSE BEGIN
wdelete, 3
ENDELSE

end

pro window_cfw, Event
common channels, bmp_vfw, bmp_vbw, bmp_cfw, bmp_cbw, bmp_lfw, bmp_lbw, bmp_ldos, set_channels
chbox_cfw=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_CFW')
chbox_set = widget_info(chbox_cfw, /button_set)

IF (chbox_set EQ 1) THEN BEGIN
dr, bmp_cfw, 1, "Current FW"

ENDIF ELSE BEGIN
wdelete, 1
ENDELSE

end

pro window_cbw, Event
common channels, bmp_vfw, bmp_vbw, bmp_cfw, bmp_cbw, bmp_lfw, bmp_lbw, bmp_ldos, set_channels
chbox_cbw=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_CBW')
chbox_set = widget_info(chbox_cbw, /button_set)

IF (chbox_set EQ 1) THEN BEGIN
dr, bmp_cbw, 2, "Current BW"

ENDIF ELSE BEGIN
wdelete, 2
ENDELSE

end

pro window_lfw, Event
common channels, bmp_vfw, bmp_vbw, bmp_cfw, bmp_cbw, bmp_lfw, bmp_lbw, bmp_ldos, set_channels
chbox_lfw=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_LFW')
chbox_set = widget_info(chbox_lfw, /button_set)

IF (chbox_set EQ 1) THEN BEGIN
dr, bmp_lfw, 5, "Lock-in FW"

ENDIF ELSE BEGIN
wdelete, 5
ENDELSE

end

pro window_lbw, Event
common channels, bmp_vfw, bmp_vbw, bmp_cfw, bmp_cbw, bmp_lfw, bmp_lbw, bmp_ldos, set_channels
chbox_lbw=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_LBW')
chbox_set = widget_info(chbox_lbw, /button_set)

IF (chbox_set EQ 1) THEN BEGIN
dr, bmp_lbw,6, "Lock-in BW"

ENDIF ELSE BEGIN
wdelete, 6
ENDELSE
end

pro window_ldos, Event
common channels, bmp_vfw, bmp_vbw, bmp_cfw, bmp_cbw, bmp_lfw, bmp_lbw, bmp_ldos, set_channels
chbox_ldos=widget_info(Event.top, FIND_BY_UNAME='WID_CHBOX_LDOS')
chbox_set = widget_info(chbox_ldos, /button_set)

IF (chbox_set EQ 1) THEN BEGIN
;WINDOW, 7, XSIZE=512, YSIZE=512, TITLE = "LDOS"
;tv, bmp_ldos
dr, bmp_ldos, 7, "LDOS Map"

ENDIF ELSE BEGIN
wdelete, 7
ENDELSE
end
;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released.
;       Normal buttons do not generate events when released, so
;       SELECT will always be 1. However, toggle buttons (created by
;       parenting a button to an exclusive or non-exclusive base)
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
PRO activate_window, Event
common data, bmp
common active_window, active_window
common channels, bmp_vfw, bmp_vbw, bmp_cfw, bmp_cbw, bmp_lfw, bmp_lbw, bmp_ldos, set_channels
common lineexport, scan, lex_vfw, lex_vbw, lex_cfw, lex_cbw, lex_lfw, lex_lbw, lex_ldos

active_window = 0

rbut_vfw=widget_info(Event.top, FIND_BY_UNAME='WID_RBUT_VFW')
IF (widget_info(rbut_vfw, /button_set) EQ 1) THEN active_window = 3

rbut_vbw=widget_info(Event.top, FIND_BY_UNAME='WID_RBUT_VBW')
IF (widget_info(rbut_vbw, /button_set) EQ 1) THEN active_window = 4

rbut_cfw=widget_info(Event.top, FIND_BY_UNAME='WID_RBUT_CFW')
IF (widget_info(rbut_cfw, /button_set) EQ 1) THEN active_window = 1

rbut_cbw=widget_info(Event.top, FIND_BY_UNAME='WID_RBUT_CBW')
IF (widget_info(rbut_cbw, /button_set) EQ 1) THEN active_window = 2

rbut_lfw=widget_info(Event.top, FIND_BY_UNAME='WID_RBUT_LFW')
IF (widget_info(rbut_lfw, /button_set) EQ 1) THEN active_window = 5

rbut_lbw=widget_info(Event.top, FIND_BY_UNAME='WID_RBUT_LBW')
IF (widget_info(rbut_lbw, /button_set) EQ 1) THEN active_window = 6

rbut_ldos=widget_info(Event.top, FIND_BY_UNAME='WID_RBUT_LDOS')
IF (widget_info(rbut_ldos, /button_set) EQ 1) THEN active_window = 7

CASE active_window OF
    1: dr, bmp_cfw, 0;, "Working  Current FW", 1
    2: dr, bmp_cbw, 0;, "Working  Current BW", 1
    3: dr, bmp_vfw, 0;, "Working  Voltage FW", 1
    4: dr, bmp_vbw, 0;, "Working  Voltage BW", 1
    5: dr, bmp_lfw, 0;, "Working  Lock-in FW", 1
    6: dr, bmp_lbw, 0;, "Working  Lock-in BW", 1
    7: dr, bmp_ldos, 0
ENDCASE
CASE active_window OF
    1: bmp=bmp_cfw
    2: bmp=bmp_cbw
    3: bmp=bmp_vfw
    4: bmp=bmp_vbw
    5: bmp=bmp_lfw
    6: bmp=bmp_lbw
    7: bmp=bmp_ldos
ENDCASE
CASE active_window OF
    1: scan=lex_cfw
    2: scan=lex_cbw
    3: scan=lex_vfw
    4: scan=lex_vbw
    5: scan=lex_lfw
    6: scan=lex_lbw
    7: scan=bmp_ldos
ENDCASE
END

;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released.
;       Normal buttons do not generate events when released, so
;       SELECT will always be 1. However, toggle buttons (created by
;       parenting a button to an exclusive or non-exclusive base)
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------



pro update_data, source
;Podle nastavenho active_window aktualizuje zdrojov kanl v ppad prav typu plain_substraction
common channels, bmp_vfw, bmp_vbw, bmp_cfw, bmp_cbw, bmp_lfw, bmp_lbw, bmp_ldos, set_channels
common active_window, active_window

case active_window  of
    1: bmp_cfw = source
    2: bmp_cbw = source
    3: bmp_vfw = source
    4: bmp_vbw = source
    5: bmp_lfw = source
    6: bmp_lbw = source
    7: bmp_ldos = source
endcase
end

pro update_lex, source
;Podle nastavenho active_window aktualizuje zdrojov kanl v ppad prav typu plain_substraction
common lineexport, scan, lex_vfw, lex_vbw, lex_cfw, lex_cbw, lex_lfw, lex_lbw, lex_ldos
common active_window, active_window

case active_window  of
    1: lex_cfw = source
    2: lex_cbw = source
    3: lex_vfw = source
    4: lex_vbw = source
    5: lex_lfw = source
    6: lex_lbw = source
    7: lex_ldos = source
endcase


end
;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released.
;       Normal buttons do not generate events when released, so
;       SELECT will always be 1. However, toggle buttons (created by
;       parenting a button to an exclusive or non-exclusive base)
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro expotr_im, Event

end
;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released.
;       Normal buttons do not generate events when released, so
;       SELECT will always be 1. However, toggle buttons (created by
;       parenting a button to an exclusive or non-exclusive base)
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro export_jpg, Event

end
;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;
;   ID is the widget ID of the component generating the event. TOP is
;       the widget ID of the top level widget containing ID. HANDLER
;       contains the widget ID of the widget associated with the
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released.
;       Normal buttons do not generate events when released, so
;       SELECT will always be 1. However, toggle buttons (created by
;       parenting a button to an exclusive or non-exclusive base)
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro export_img, Event

end
